unit crRunOnce;

interface
uses
  Windows, Forms;



  function HasPrevInstance: Boolean;

  function ReadAtom(aAtom: Word): string;

var
  WM_RUNONCE_DATA_MSG: cardinal;

implementation


function ReadAtom(aAtom: Word): string;
begin
  try
    SetLength(Result, MAXBYTE);
    // "Dcodage" du texte prsent dans l'atom
    // et mise  jour de sa taille
    SetLength(Result, GlobalGetAtomName(aAtom, PChar(Result), MAXBYTE));
  finally
    // suppression de l'atom
    GlobalDeleteAtom(aAtom);
  end;
end;

function IsPrevInstance: HWND;
var
  ClassName: array[0..MAXBYTE] of char;
  Title: string;
begin
  Title := Application.Title;
  Application.Title := 'Yo!';
  { On change le titre, car on trouverait toujours une application lance, (la notre). }
  try
    GetClassName(Application.Handle, ClassName, MAXBYTE);
    { Met dans ClassName le nom de la classe de l'application. }
    Result := FindWindow(ClassName, PChar(Title));
    { Renvoie le Handle de la 1re fentre de Class (Type) ClassName, et le titre de l'application. }
  finally
    Application.Title := Title; { Restauration du vrai titre. }
  end;
end;

procedure AfficherInstance(InstHandle: HWND);
var
  I: Integer;
begin
  { Restaurer l'application si minimise }
  ShowWindow(InstHandle, SW_RESTORE);
  { Mettre la premire instance en premier plan : }
  SetForegroundWindow(InstHandle);

  // Informe la premire instance qu'une 2me instance a t lance 
  PostMessage(InstHandle, WM_RUNONCE_DATA_MSG, 0, 0);
  // passer paramtres  la premire instance
  for I := 1 to ParamCount do
    PostMessage(InstHandle, WM_RUNONCE_DATA_MSG, GlobalAddAtom(PChar(ParamStr(I))), 0);

  { Fin de la deuxime instance }
  Application.Terminate;
end;

function HasPrevInstance: Boolean;
var
  HWNDPrevInstance: HWND;
begin
  HWNDPrevInstance := IsPrevInstance;
  Result := HWNDPrevInstance <> 0;
  if Result then
    AfficherInstance(HWNDPrevInstance);
end;

initialization
  WM_RUNONCE_DATA_MSG := RegisterWindowMessage('RunOnce Data Message');
end.
